var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import Ripple from '../ripple/ripple';

var Button = function (_Component) {
  _inherits(Button, _Component);

  function Button() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Button);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Button.__proto__ || Object.getPrototypeOf(Button)).call.apply(_ref, [this].concat(args))), _this), _this.getRippleRef = function (component) {
      _this.rippleComponent = component;
    }, _this.onClick = function (e) {
      var onClick = _this.props.onClick;


      if (_this.rippleComponent) {
        _this.rippleComponent.onClick(e);
      }

      if (onClick) {
        onClick();
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Button, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          _props$className = _props.className,
          className = _props$className === undefined ? '' : _props$className,
          _props$raised = _props.raised,
          raised = _props$raised === undefined ? false : _props$raised,
          _props$flat = _props.flat,
          flat = _props$flat === undefined ? false : _props$flat,
          _props$stroked = _props.stroked,
          stroked = _props$stroked === undefined ? false : _props$stroked,
          _props$compact = _props.compact,
          compact = _props$compact === undefined ? flat : _props$compact,
          _props$ripple = _props.ripple,
          ripple = _props$ripple === undefined ? true : _props$ripple,
          otherProps = _objectWithoutProperties(_props, ['children', 'className', 'raised', 'flat', 'stroked', 'compact', 'ripple']);

      var componentClassNames = classnames('mt-button', className, {
        'mt-button-raised': raised,
        'mt-button-flat': flat,
        'mt-button-stroked': stroked,
        'mt-button-compact': compact
      });

      return React.createElement(
        'button',
        _extends({}, otherProps, {
          className: componentClassNames,
          onClick: this.onClick }),
        ripple && React.createElement(Ripple, { ref: this.getRippleRef }),
        children
      );
    }
  }]);

  return Button;
}(Component);

Button.PropTypes = {
  className: PropTypes.string,
  raised: PropTypes.bool,
  flat: PropTypes.bool,
  stroked: PropTypes.bool,
  compact: PropTypes.bool,
  ripple: PropTypes.bool,
  onClick: PropTypes.func
};

export default Button;