'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _ripple = require('../ripple/ripple');

var _ripple2 = _interopRequireDefault(_ripple);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

let Button = function (_Component) {
  _inherits(Button, _Component);

  function Button(...args) {
    var _temp, _this, _ret;

    _classCallCheck(this, Button);

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call(this, ...args)), _this), _this.getRippleRef = component => {
      _this.rippleComponent = component;
    }, _this.onClick = e => {
      const onClick = _this.props.onClick;


      if (_this.rippleComponent) {
        _this.rippleComponent.onClick(e);
      }

      if (onClick) {
        onClick();
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  Button.prototype.render = function render() {
    var _props = this.props;
    const children = _props.children;
    var _props$className = _props.className;
    const className = _props$className === undefined ? '' : _props$className;
    var _props$raised = _props.raised;
    const raised = _props$raised === undefined ? false : _props$raised;
    var _props$flat = _props.flat;
    const flat = _props$flat === undefined ? false : _props$flat;
    var _props$stroked = _props.stroked;
    const stroked = _props$stroked === undefined ? false : _props$stroked;
    var _props$compact = _props.compact;
    const compact = _props$compact === undefined ? flat : _props$compact;
    var _props$ripple = _props.ripple;

    const ripple = _props$ripple === undefined ? true : _props$ripple,
          otherProps = _objectWithoutProperties(_props, ['children', 'className', 'raised', 'flat', 'stroked', 'compact', 'ripple']);

    const componentClassNames = (0, _classnames2.default)('mt-button', className, {
      'mt-button-raised': raised,
      'mt-button-flat': flat,
      'mt-button-stroked': stroked,
      'mt-button-compact': compact
    });

    return _react2.default.createElement(
      'button',
      _extends({}, otherProps, {
        className: componentClassNames,
        onClick: this.onClick }),
      ripple && _react2.default.createElement(_ripple2.default, { ref: this.getRippleRef }),
      children
    );
  };

  return Button;
}(_react.Component);

Button.PropTypes = {
  className: _propTypes2.default.string,
  raised: _propTypes2.default.bool,
  flat: _propTypes2.default.bool,
  stroked: _propTypes2.default.bool,
  compact: _propTypes2.default.bool,
  ripple: _propTypes2.default.bool,
  onClick: _propTypes2.default.func
};

exports.default = Button;