'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

let Ripple = function (_Component) {
  _inherits(Ripple, _Component);

  function Ripple(...args) {
    var _temp, _this, _ret;

    _classCallCheck(this, Ripple);

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call(this, ...args)), _this), _this.state = {
      active: false,
      top: 0,
      left: 0
    }, _this.onClick = e => {
      const wasMouseClick = e.nativeEvent.x && e.nativeEvent.y;
      const left = wasMouseClick ? `${e.nativeEvent.layerX}px` : '50%';
      const top = wasMouseClick ? `${e.nativeEvent.layerY}px` : '50%';

      _this.setState({
        active: false,
        top,
        left
      });

      _this.activeTimeout = setTimeout(() => {
        _this.setState({
          active: true
        });
      }, 25);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  Ripple.prototype.render = function render() {
    var _state = this.state;
    const active = _state.active,
          top = _state.top,
          left = _state.left;


    const classname = (0, _classnames2.default)('mt-ripple', {
      'mt-ripple-active': active
    });
    const styles = {
      '--mt-ripple-top': top,
      '--mt-ripple-left': left
    };

    return _react2.default.createElement('span', { style: styles, className: classname, onClick: this.onClick });
  };

  Ripple.prototype.componentWillUnmount = function componentWillUnmount() {
    clearTimeout(this.activeTimeout);
  };

  return Ripple;
}(_react.Component);

exports.default = Ripple;